from concurrent import futures
import time


def test(sleep_time, fail=False):
    """Simple async function"""
    time.sleep(sleep_time)
    if fail:
        raise RuntimeError('failing as asked')
    return True


def callback(future):
    excp = future.exception()
    if excp:
        print('Future %d raised : %s' % (future.num, excp))
    else:
        print('Future %d returned : %s' % (future.num, future.result()))


def main():
    executor = futures.ThreadPoolExecutor(max_workers=2)
    future1 = executor.submit(test, 0.6)
    future2 = executor.submit(test, 0.4, True)
    future1.num = 1
    future2.num = 2
    future1.add_done_callback(callback)
    future2.add_done_callback(callback)
    while future2.running() or future1.running():
        print('futures still running')
        time.sleep(0.1)


if __name__ == '__main__':
    main()
